#!/bin/bash
if [ "$#" -ne 1 ]; then
  echo "You must supply a base OS name"
  exit 2
fi

if [ $1 == "alpine" ]
then
  imgname="uhexpalpine"
elif [ $1 == "ubuntu" ]
then
  imgname="uhexptest"
else
  echo "You did not provide a valid base OS name"
  exit 2
fi

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
pushd $DIR
pushd ..
sudo python setup.py clean
popd
popd
CTID=`sudo docker run -d -h uhlt --name=uhexp-test-1 --memory=256m --memory-swap=-1 -v $DIR/..:/lab-tools $imgname:1`
sudo docker exec -ti $CTID sh -c "cd lab-tools; python setup.py install"
sudo docker exec -ti $CTID bash
sudo docker kill $CTID
sudo docker rm $CTID
