import logging
logging.getLogger().setLevel(logging.DEBUG)

import subprocess
import time
import psutil

import uhexp.apps.tcpdump
inst = uhexp.apps.tcpdump.Installer(logging)
inst.install()

app = uhexp.apps.tcpdump.TCPDump("test.pcap", "eth0", logh = logging)
app.start()

try:
  proc = psutil.Process(app.pid)
  logging.info("PASS")
except psutil.NoSuchProcess:
  logging.error("FAIL")

time.sleep(3)

try:
  app.stop()
  logging.info("PASS")
except psutil.NoSuchProcess:
  logging.error("FAIL")

gone, alive = psutil.wait_procs([proc], timeout=5)

if alive:
  logging.error("FAIL")
  logging.error(alive)
else:
  logging.info("PASS")

