# Copyright (c) 2016-2018  University of Houston

from __future__ import absolute_import

from . import LocalApplication, InstallableApplication


class Curl(LocalApplication):
  def __init__ (self, url, logh = None):
    super(Curl, self).__init__("curl", logh)
    self.url = url
    self._binpath_alpine = "nohup /usr/bin/curl"
    self._binpath_raspbian = "/usr/bin/curl"
    self._binpath_ubuntu = "/usr/bin/curl"

  def start (self, insecure = False, block = False):
    if insecure:
      cmd = "%s %s -k -N -s -f -v -O" % (self.binpath, self.url)
    else:
      cmd = "%s %s -N -s -f -v -O" % (self.binpath, self.url)
    return self.call(cmd, block = block)


class Installer(InstallableApplication):
  def __init__ (self, logh):
    super(Installer, self).__init__("curl", logh)

  def install_ubuntu (self):
    self.call("%s curl" % (self.APT))

  def install_alpine (self):
    self.call("%s curl" % (self.APK))
