# Copyright (c) 2018  University of Houston

from __future__ import absolute_import

import json
import os.path
import signal

from . import LocalApplication, ApplicationManager, InstallableApplication

class DOENF(LocalApplication):
  def __init__ (self, inintf, outintf, filter_data, logh = None):
    super(DOENF, self).__init__("doenf", logh)
    self._binpath_alpine = "onedir"
    self._binpath_ubuntu = "onedir"

    filter_data = json.loads(filter_data)
    self.inintf = inintf
    self.outintf = outintf
    idx = 0
    PATH = "filter.json"
    while os.path.exists(PATH):
      PATH = "%s.%d"% (PATH, idx)
      idx += 1
    with open(PATH, "w+") as f:
      f.write(json.dumps(filter_data))
    self.path = PATH

  def start (self):
    cmdl = ["onedir", self.inintf, self.outintf, self.path]
    self.pid = self.call(" ".join(cmdl), block=False)
    ApplicationManager.writePID(self)
    return self.pid

  def stop (self):
    self.kill(signal.SIGTERM)

