# Copyright (c) 2017  University of Houston

from __future__ import absolute_import

from . import LocalService, InstallableApplication

class Nginx(LocalService):
  def __init__ (self, logh = None):
    super(Nginx, self).__init__("nginx", logh)

  def start_supervisor (self):
    self.call("supervisorctl start nginx")

  def stop_supervisor (self):
    self.call("supervisorctl stop nginx")

  def start_upstart (self):
    self.call("service nginx start")

  def stop_upstart (self):
    self.call("service nginx stop")

  def start_systemd (self):
    self.call("systemctl start nginx")

  def stop_systemd (self):
    self.call("systemctl stop nginx")


class Installer(InstallableApplication):
  def __init__ (self, logh):
    super(Installer, self).__init__("nginx", logh)

  def install_alpine (self):
    self.call("%s nginx" % (self.APK))
