# Copyright (c) 2016-2018  University of Houston

from __future__ import absolute_import

from . import LocalApplication, InstallableApplication, ApplicationManager
from ..util import call


class TFTP(LocalApplication):
  def __init__ (self, filename, serverip, logh = None):
    super(TFTP, self).__init__("tftp", logh)
    self._binpath_ubuntu = "/usr/bin/tftp"

    # TODO: Filename should be a real list instead of a string
    # if multiple files, specify out1.file out2.file outn.file etc...
    self.filename = filename
    self.serverip = serverip

  def start (self, block = False):
    cmd = "%s %s -c get %s" % (self.binpath, self.serverip, self.filename)
    if block:
      return self.call(cmd, block = block)
    else:
      self.pid = self.call(cmd, block = block)
      ApplicationManager.writePID(self)


class Installer(InstallableApplication):
  def __init__ (self, logh):
    super(Installer, self).__init__("tftp", logh)

  def install_ubuntu (self):
    call("%s tftp-hpa" % (self.APT), self.logh)
