# Copyright (c) 2016-2018  University of Houston

from __future__ import absolute_import

from . import LocalService, InstallableApplication

from ..util import call

class VSFTPD(LocalService):
  def __init__ (self, logh = None):
    super(VSFTPD, self).__init__("vsftpd", logh)

  def start_upstart (self):
    cmd = "sudo service vsftpd start"
    self.call(cmd)

  def stop_upstart (self):
    cmd = "sudo service vsftpd stop"
    self.call(cmd)


class Installer(InstallableApplication):
  CONF = """listen=YES
anonymous_enable=YES
local_enable=YES
dirmessage_enable=YES
use_localtime=YES
xferlog_file=/var/log/vsftpd.log
xferlog_enable=YES
connect_from_port_20=YES
#ls_recurse_enable=YES
secure_chroot_dir=/var/run/vsftpd/empty
"""
  CONFPATH = "/etc/vsftpd.conf"
# the clients will land on /srv/ftp/ directory at server
# this is written inside /etc/passwd file

  def __init__ (self, logh):
    super(Installer, self).__init__("vsftpd", logh)

  def install_ubuntu (self):
    call("%s vsftpd" % (self.APT), self.logh)
    VSFTPD().stop()

  def conf_ubuntu (self):
    with open(Installer.CONFPATH, "w") as conf:
      conf.write(Installer.CONF)
