# Copyright (c) 2017-2018  University of Houston

from __future__ import absolute_import

import os

from .core.bases import ClientApplication

class Base(ClientApplication):
  def __init__ (self, host):
    super(Base, self).__init__("uhexp", host)
    self.clone_uhexp = host.getAttr("uhexp.clone", False)
    if self.clone_uhexp:
      self.uhexp_url = host.getAttr("uhexp.url", "https://bitbucket.org/uh-netlab/uhexp")
      self.uhexp_branch = host.getAttr("uhexp.branch", "default")

  def _install (self, queue):
    if self.clone_uhexp:
      cmdl = "hg clone %s %s" % (self.uhexp_url, self.host.uhexp_path)
      data = self.host.run(cmdl, timeout = 60, pid = False)
      self.logh.debug(data)

      cmdl = "cd %s; hg update -C %s" % (self.host.uhexp_path, self.uhexp_branch)
      data = self.host.run(cmdl, timeout = 10, pid = False)
      self.logh.debug(data)

    cmdl = "cd %s; python setup.py install; echo $?" % (self.host.uhexp_path)
    data = self.host.run(cmdl, timeout = 60, pid = False)
    if int(data[-2].strip()) != 0:
      queue.put({"v" : 1, "success" : False, "pid" : os.getpid()})
      for item in data:
        self.logh.warning(item)
      return

    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return

