# Copyright (c) 2017-2018  University of Houston

from __future__ import absolute_import

import multiprocessing as MP

from ...util import KeyAdapter
from .processmanager import ProcessManager

class ClientApplication (object):
  def __init__ (self, name, host):
    self.name = name
    self.host = host
    self.logh = KeyAdapter(name, host.logh)
    self.pid = None

  def run (self, *args, **kwargs):
    al = list(args)
    al.insert(0, ProcessManager.queue)
    p = MP.Process(target = self._run_wrap, args=tuple(al), kwargs=kwargs)
    p.start()
    token = ProcessManager.registerJob(self.host.host, "%s [run]" % (self.name), p)
    return token

  def _run_wrap (self, *args, **kwargs):
    self.host.ssh._client = None
    self.host.ssh._transport = None
    return self._run(*args, **kwargs)

  def _run (self, *args, **kwargs): pass

  def install (self):
    p = MP.Process(target = self._install_wrap, args=(ProcessManager.queue,))
    p.start()
    token = ProcessManager.registerJob(self.host.host, "%s [install]" % (self.name), p)
    return token

  def _install_wrap (self, *args):
    self.host.ssh._client = None
    self.host.ssh._transport = None
    return self._install(*args)

  def _install (self, *args): pass

  def run_block (self): pass

  def start (self): pass

  def stop (self): pass
