# Copyright (c) 2017  University of Houston

import multiprocessing as MP
import time

class _ProcessManager(object):
  def __init__ (self):
    self.jobs = {}
    self.queue = MP.Queue()
  
  def registerJob (self, host, jobname, process):
    token = JobToken(host, jobname)
    self.jobs[process.pid] = (token, process)
    return token

  def waitForJobs (self):
    while MP.active_children():
      time.sleep(1)

    while not self.queue.empty():
      item = self.queue.get()
      if item["v"] >= 1:
        token, process = self.jobs[item["pid"]]
        token.success = item["success"]
    
    self.jobs = {}
    self.queue = MP.Queue()

class JobToken(object):
  def __init__ (self, hostname, command):
    self.hostname = hostname
    self.command = command
    self.success = False
  

ProcessManager = _ProcessManager()

def waitForJobs():
  ProcessManager.waitForJobs()
