# Copyright (c) 2017-2018  University of Houston

from __future__ import absolute_import

import os
import time

from .core.bases import ClientApplication

class Curl(ClientApplication):
  def __init__ (self, host, logh = None):
    super(Curl, self).__init__("Curl", host)
    self.timeout = 300

  def run_block (self, url):
    cmdl = """apprunner Curl '{"url" : "%s"}' -1""" % (url)
    self.host.run(cmdl, timeout = 300)
    
  def _run (self, queue, url):
    cmdl = """nohup apprunner Curl '{"url" : "%s"}' -1 & echo $!""" % (url)
    out = self.host.run(cmdl)

    self.pid = int(out[0])

    wait = 0
    while wait < self.timeout:
      if self.host.checkPID(self.pid):
        time.sleep(2)
        wait += 2
      else:
        queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
        break

    if wait >= self.timeout:
      queue.put({"v" : 1, "success" : False, "pid" : os.getpid()})

    return

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
