# Copyright (c) 2017  University of Houston

from __future__ import absolute_import

import json
import os

from .core.bases import ClientApplication

class DD(ClientApplication):
  def __init__ (self, host, logh = None):
    super(DD, self).__init__("DD", host)

  def run_block (self, ifpath, ofpath, blocksize = 1024, count = 10, timeout = 300):
    args = {"inputfile" : ifpath, "outputfile" : ofpath, "blocksize" : blocksize, "count" : count}
    cmdl = """apprunner uhexp.tools.dd:DD '%s' -1""" % (json.dumps(args))
    self.host.run(cmdl, timeout = timeout)

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
