# Copyright (c) 2018  University of Houston

from __future__ import absolute_import

import json
import os

from .core.bases import ClientApplication

class DOENF(ClientApplication):
  def __init__ (self, host, path):
    super(DOENF, self).__init__("doenf", host)
    self.path = path

  def _install (self, queue):
    cmdl = "cd %s; python setup.py install" % (self.path)
    self.host.run(cmdl, timeout = 300, pid = False)
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return

  def start (self, inintf, outintf, filter_data):
    jd = json.dumps({"inintf" : inintf, "outintf" : outintf, "filter_data" : json.dumps(filter_data)})
    self.pid = int(self.host.run("nohup apprunner DOENF '%s' & echo $!" % (jd))[0])
    cmdl = "kill -SIGUSR1 %d" % (self.pid)
    self.host.run(cmdl)

  def stop (self):
    if self.pid:
      cmdl = "kill -TERM %d" % (self.pid)
      self.host.run(cmdl)
    else:
      self.logh.warning("requested to kill absent process")
