# Copyright (c) 2017-2018  University of Houston

from __future__ import absolute_import

import json
import os

from .core.bases import ClientApplication

class DOESensor(ClientApplication):
  def __init__ (self, host, path):
    super(DOESensor, self).__init__("DOESensor", host)
    self.path = path

  def _install (self, queue):
    cmdl = "cd %s; python setup.py install" % (self.path)
    self.host.run(cmdl, timeout = 300, pid = False)
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return

  def start (self, dest_ip, stype = "random_float", interval = 1, timestamp = False, port = 20265):
    jd = """--dest-ip %s --type %s --interval %f --port %d""" % (dest_ip, stype, interval, port)
    if timestamp:
      jd += " --timestamp"
    cmdl = """nohup %s/scripts/sensor-em.py %s & echo $!""" % (self.path, jd)
    self.pid = int(self.host.run(cmdl)[0])

  def stop (self):
    if self.pid:
      cmdl = "kill -TERM %d" % (self.pid)
      self.host.run(cmdl)
    else:
      self.logh.warning("requested to kill absent process")
