# Copyright (c) 2017  University of Houston

from __future__ import absolute_import

import os
import time
import json

from .core.bases import ClientApplication

class GenericApp(ClientApplication):
  def __init__ (self, host, logh = None):
    super(GenericApp, self).__init__("GenericApp", host)
    #self.timeout = 300

  def start (self, args_g, appbinpath):
    data = {"args_g" : args_g, "appbinpath" : appbinpath}
    if self.host.os == "alpine":
      cmdl = """nohup apprunner GenericApp '%s' -2 & echo $!""" % (json.dumps(data))
      out = self.host.run(cmdl)
      for line in out:
        if len(line) >= 1 and len(line) < 8:
          self.logh.debug("Possible PID line: %s" % (line))
          self.pid = int(line)
          return
    else:
      cmdl = """nohup apprunner GenericApp '%s' -2 & echo $!""" % (json.dumps(data))
      self.pid = int(self.host.run(cmdl)[0])
      #cmdl = "kill -SIGUSR1 %d" % (self.pid)
      #self.host.run(cmdl)
  
  def stop (self):
    if self.pid:
      cmdl = "kill -TERM %d" % (self.pid)
      self.host.run(cmdl)
    else:
      self.logh.warning("requested to kill absent process")

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
