# Copyright (c) 2017-2018 University of Houston

from __future__ import absolute_import

import json
import os
import time

from .core.bases import ClientApplication

class iPerfC(ClientApplication):
  def __init__ (self, host, logh = None):
    super(iPerfC, self).__init__("iperfc", host)
    self.timeout = 300

  def run_block (self, serverIP, bitrate = 100, duration = 30):
    args = {"endpoint" : serverIP, "bitrate": bitrate, "duration": duration}
    cmdl = """apprunner uhexp.apps.iperf:iPerfC '%s' -1""" % (json.dumps(args))
    self.host.run(cmdl, timeout = 300)

  def _run (self, queue, serverIP, bitrate = 100, duration = 30):
    args = {"endpoint" : serverIP, "bitrate": bitrate, "duration": duration}
    cmdl = """nohup apprunner uhexp.apps.iperf:iPerfC '%s' -1 & echo $!""" % (json.dumps(args))
    self.pid = int(self.host.run(cmdl)[0])

    wait = 0
    while wait < self.timeout:
      if self.host.checkPID(self.pid):
        time.sleep(2)
        wait += 2
      else:
        queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
        break

    if wait >= self.timeout:
      queue.put({"v" : 1, "success" : False, "pid" : os.getpid()})

    return

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return

