# Copyright (c) 2017  University of Houston

from __future__ import absolute_import

import json
import os

from .core.bases import ClientApplication

class NetCat(ClientApplication):
  def __init__ (self, host, logh = None):
    super(NetCat, self).__init__("NetCat", host)

  def start (self, protocol, port):
    jd = json.dumps({"proto" : protocol, "port" : port})
    cmdl = """nohup apprunner Netcat '%s' & echo $!""" % (jd)
    self.pid = int(self.host.run(cmdl)[0])
    cmdl = "kill -SIGUSR1 %d" % (self.pid)
    self.host.run(cmdl)
     
  def stop (self):
    if self.pid:
      cmdl = "kill -TERM %d" % (self.pid)
      self.host.run(cmdl)
    else:
      self.logh.warning("requested to kill absent process")

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
