# Copyright (c) 2017  University of Houston

from __future__ import absolute_import

import os

from .core.bases import ClientApplication


class Nginx(ClientApplication):
  def __init__ (self, host, logh = None):
    super(Nginx, self).__init__("Nginx", host)

  def start (self):
    cmdl = """nohup apprunner Nginx '{}' & echo $!"""
    out = self.host.run(cmdl)
    self.logh.debug(str(out))
    self.pid = int(out[0])
    cmdl = "kill -SIGUSR1 %d" % (self.pid)
    self.host.run(cmdl)
  
  def stop (self):
    cmdl = "kill -TERM %d" % (self.pid)
    self.host.run(cmdl)

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
