# Copyright (c) 2018  University of Houston

from __future__ import absolute_import

import json
import os
import time

from .core.bases import ClientApplication

class Ping(ClientApplication):
  def __init__ (self, host, logh = None):
    super(Ping, self).__init__("Ping", host)

  def run_block (self, dest, count = 1, timestamp = False, interval = None, size = None):
    args = {"dest" : dest, "count" : count, "timestamp" : timestamp, "interval" : interval, "size" : size}
    cmdl = """apprunner Ping '%s' -1""" % (json.dumps(args))
    self.host.run(cmdl, timeout = count*10)

  def _run (self, queue, dest, count = 1, timestamp = False, interval = 1, size = None):
    args = {"dest" : dest, "count" : count, "timestamp" : timestamp, "interval" : interval, "size" : size}
    cmdl = """nohup apprunner Ping '%s' -1 & echo $!""" % (json.dumps(args))
    self.pid = int(self.host.run(cmdl)[0])

    timeout = count * interval * 10
    exp_wait = wait = count * interval
    time.sleep(exp_wait)

    while wait < timeout:
      if self.host.checkPID(self.pid):
        time.sleep(1)
        wait += 1
      else:
        queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
        break
    if wait >= timeout:
      queue.put({"v" : 1, "success" : False, "pid" : os.getpid()})

    return

  def _install (self, queue):
    # TODO: some install method here using uhexp instmng when ready
    queue.put({"v" : 1, "success" : True, "pid" : os.getpid()})
    return
