# Copyright (c) 2016-2018  University of Houston

from __future__ import absolute_import

from ..apps import LocalApplication, InstallableApplication

class DD(LocalApplication):
  def __init__ (self, inputfile, outputfile, blocksize = 1024, count = 100, logh = None):
    super(DD, self).__init__("dd", logh)
    self._binpath_ubuntu = "/bin/dd"
    self._binpath_alpine = "/bin/dd"
    self._binpath_raspbian = "/bin/dd"

    self.inputfile = inputfile
    self.outputfile = outputfile
    self.blocksize = blocksize
    self.count = count

  def start (self, block = False):
    cmd = "%s if=%s of=%s bs=%d count=%d" % (self.binpath, self.inputfile,
                                              self.outputfile, self.blocksize, self.count)
    return self.call(cmd, block = block)

class Installer(InstallableApplication):
  def __init__ (self, logh):
    super(Installer, self).__init__("coreutils", logh)

  def install_ubuntu (self):
    self.call("%s coreutils" % (self.APT))

  def install_alpine (self):
    self.call("%s coreutils" % (self.APK))

  def install_raspbian (self):
    self.call("%s coreutils" % (self.APT))
