# Copyright (c) 2016-2017  University of Houston

from __future__ import absolute_import

from ..apps import InstallableApplication
from ..util import call


class Installer(InstallableApplication):
  def __init__ (self, logh):
    super(Installer, self).__init__("geni-lib", logh)

  def install_ubuntu (self):
    try:
      call("%s mercurial build-essential python-setuptools libxml2-dev python-dev \
            libxslt1-dev zlib1g-dev libffi-dev libssl-dev" % (self.APT), self.logh)
      call("hg clone https://bitbucket.org/barnstorm/geni-lib", self.logh)
      call("cd geni-lib;hg update -C 0.9-DEV", self.logh)
      call("cd geni-lib;sudo pip install .", self.logh)
    except Exception:
      self.logh.exception("Exception in install_ubuntu")

  def conf_ubuntu (self, bundle, pubkey = None, certkey = None):
    try:
      arglist = ["context-from-bundle --bundle %s" % (bundle)]
      if pubkey:
        arglist.append("--pubkey %s" % (pubkey))
      if certkey:
        arglist.append("--cert-private-key %s" % (certkey))
      call(" ".join(arglist), self.logh)
    except Exception:
      self.logh.exception("Exception in conf_ubuntu")
